commit 4ea18a07d5e39ca20993e9b7ec61f20f1777757b
Author: Svenja <skenneweg@techfak.uni-bielefeld.de>
Date:   Thu Jun 25 15:54:02 2020 +0200

    Fixed some warnings

diff --git a/src/urt_node.c b/src/urt_node.c
index 228fa83..76e64fa 100644
--- a/src/urt_node.c
+++ b/src/urt_node.c
@@ -37,9 +37,6 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 /* LOCAL VARIABLES                                                            */
 /******************************************************************************/
 
-urt_node_t localNode;
-static  URT_THREAD_MEMORY(_node_thread, AMIROOS_CFG_SHELL_STACKSIZE); //TODO: not here
-
 /******************************************************************************/
 /* LOCAL FUNCTIONS                                                            */
 /******************************************************************************/
@@ -51,12 +48,13 @@ static  URT_THREAD_MEMORY(_node_thread, AMIROOS_CFG_SHELL_STACKSIZE); //TODO: no
  */
 void _main(void* arg)
 {
+  urt_node_t* localNode = (urt_node_t*)arg;
   urt_osEventMask_t mask;
   urt_osEventFlags_t flag = 0;
-  urtEventRegister(urtCoreGetEvtSource(), &localNode.listener, mask, flag);
-  if (localNode.setupcallback != NULL)
+  urtEventRegister(urtCoreGetEvtSource(), &(localNode->listener), mask, flag);
+  if (localNode->setupcallback != NULL)
   {
-    mask = localNode.setupcallback(&localNode, arg);
+    mask = localNode->setupcallback(localNode, localNode->setupparams);
     if (mask == urtCoreGetEventMask())
     {
         urtCoreStopNodes(URT_STATUS_NODE_INVALEVTMASK);
@@ -64,7 +62,7 @@ void _main(void* arg)
   }
   else
   {
-     mask = ALL_EVENTS;
+     mask = URT_EVENTMASK_ALL;
   }
 
   if (urtCoreGetStatus() == URT_STATUS_OK)
@@ -77,9 +75,9 @@ void _main(void* arg)
     urt_osEventMask_t temp = urtEventWait(mask, URT_EVENT_WAIT_ONE, URT_DELAY_INFINITE);
     if (temp == urtCoreGetEventMask())
     {
-      localNode.loopcallback(&localNode, mask, arg);
+      localNode->loopcallback(localNode, mask, localNode->loopparams);
       #if (URT_CFG_PUBSUB_PROFILING || URT_CFG_RPC_PROFILING)
-        localNode.loops++;
+        localNode->loops++;
       #endif /* URT_CFG_PUBSUB_PROFILING || URT_CFG_RPC_PROFILING */
       if (mask == urtCoreGetEventMask())
       {
@@ -88,13 +86,13 @@ void _main(void* arg)
     }
   }
 
-  if (localNode.shutdowncallback)
+  if (localNode->shutdowncallback)
   {
-    localNode.shutdowncallback(&localNode, urtCoreGetStatus(), arg);
+    localNode->shutdowncallback(localNode, urtCoreGetStatus(), localNode->shutdownparams);
   }
-  urtEventUnregister(urtCoreGetEvtSource(), &localNode.listener);
+  urtEventUnregister(urtCoreGetEvtSource(), &localNode->listener);
 
-  urt_osThread_t* threadToTerminate = localNode.thread;
+  urt_osThread_t* threadToTerminate = localNode->thread;
   while (threadToTerminate->children != NULL || threadToTerminate->sibling != NULL)
   {
     if (threadToTerminate->children != NULL)
@@ -104,7 +102,7 @@ void _main(void* arg)
   }
   urtThreadTerminate(&threadToTerminate, URT_THREAD_TERMINATE_REQUEST);
 
-  urt_osThread_t* threadToJoin = localNode.thread;
+  urt_osThread_t* threadToJoin = localNode->thread;
   while (threadToJoin->children != NULL || threadToJoin->sibling != NULL)
   {
     if (threadToJoin->children != NULL)
@@ -140,9 +138,9 @@ void _main(void* arg)
  *                            Must be NULL if no shutdown callback is specified.
  *                            May be NULL if the specified shutdown callback does not expect parameters.
  */
-void urtNodeInit(urt_node_t* node, urt_osThread_t* thread, urt_osThreadPrio_t prio, urt_nodeSetupCallback_t* setupcallback,
-                 void* setupparams, urt_nodeLoopCallback_t* loopcallback, void* loopparams,
-                 urt_nodeShutdownCallback_t* shutdowncallback, void* shutdownparams)
+void urtNodeInit(urt_node_t* node, urt_osThread_t* thread, urt_osThreadPrio_t prio, urt_nodeSetupCallback_t setupcallback,
+                 void* setupparams, urt_nodeLoopCallback_t loopcallback, void* loopparams,
+                 urt_nodeShutdownCallback_t shutdowncallback, void* shutdownparams)
 {
   urtDebugAssert(node != NULL);
   urtDebugAssert(thread == NULL);
@@ -150,7 +148,7 @@ void urtNodeInit(urt_node_t* node, urt_osThread_t* thread, urt_osThreadPrio_t pr
     urtDebugAssert(setupparams == NULL);
 
   node->next = NULL;
-  node->thread = urtThreadInit(_node_thread, sizeof(_node_thread), prio, _main, setupparams);
+  node->thread = urtThreadInit(thread, sizeof(thread), prio, _main, node);
   node->setupcallback = setupcallback;
   node->setupparams = setupparams;
   node->loopcallback = loopcallback;
@@ -168,6 +166,5 @@ void urtNodeInit(urt_node_t* node, urt_osThread_t* thread, urt_osThreadPrio_t pr
     urt_node_t* nodeCore = urtCoreGetNodes();
     nodeCore = node;
   urtMutexUnlock(mutexTemp);
-  localNode = *node;
   return;
 }