commit cd21e832e96168d1dbcdd2ac829ab348988841b9
Author: skenneweg <skenneweg@techfak.uni-bielefeld.de>
Date:   Sun May 10 12:39:40 2020 +0200

    Changed depth of indentation

diff --git a/inc/urt_subscriber.h b/inc/urt_subscriber.h
index dc22b35..e6be66b 100644
--- a/inc/urt_subscriber.h
+++ b/inc/urt_subscriber.h
@@ -47,14 +47,14 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 typedef struct urt_basesubscriber
 {
-    urt_topic_t* topic;
-    urt_osEventListener_t evtListener;
-    urt_message_t* lastMessage;
-    urt_osTime_t lastMessageTime;
-    #if (URT_CFG_PUBSUB_PROFILING)
-        uint64_t sumLatencies;
-        uint64_t numMessagesReceived;
-    #endif /* URT_CFG_PUBSUB_PROFILING */
+  urt_topic_t* topic;
+  urt_osEventListener_t evtListener;
+  urt_message_t* lastMessage;
+  urt_osTime_t lastMessageTime;
+  #if (URT_CFG_PUBSUB_PROFILING)
+    uint64_t sumLatencies;
+    uint64_t numMessagesReceived;
+  #endif /* URT_CFG_PUBSUB_PROFILING */
 }urt_basesubscriber_t;
 
 /**
@@ -62,11 +62,11 @@ typedef struct urt_basesubscriber
  */
 typedef struct urt_nrtsubscriber
 {
-    urt_basesubscriber_t base;
-    #if (URT_CFG_PUBSUB_PROFILING)
-        urt_delay_t minLatency;
-        urt_delay_t maxLatency;
-    #endif /* URT_CFG_PUBSUB_PROFILING */
+  urt_basesubscriber_t base;
+  #if (URT_CFG_PUBSUB_PROFILING)
+    urt_delay_t minLatency;
+    urt_delay_t maxLatency;
+  #endif /* URT_CFG_PUBSUB_PROFILING */
 }urt_nrtsubscriber_t;
 
 /**
@@ -74,12 +74,12 @@ typedef struct urt_nrtsubscriber
  */
 typedef struct urt_srtsubscriber
 {
-    urt_basesubscriber_t base;
-    urt_srtusefulnessfunc_t* usefulnesscb;
-    #if (URT_CFG_PUBSUB_PROFILING)
-        urt_delay_t minLatency;
-        urt_delay_t maxLatency;
-    #endif /* URT_CFG_PUBSUB_PROFILING */
+  urt_basesubscriber_t base;
+  urt_srtusefulnessfunc_t* usefulnesscb;
+  #if (URT_CFG_PUBSUB_PROFILING)
+    urt_delay_t minLatency;
+    urt_delay_t maxLatency;
+  #endif /* URT_CFG_PUBSUB_PROFILING */
 }urt_srtsubscriber_t;
 
 /**
@@ -87,17 +87,17 @@ typedef struct urt_srtsubscriber
  */
 typedef struct urt_frtsubscriber
 {
-    urt_basesubscriber_t base;
-    #if (URT_CFG_PUBSUB_QOS_DEADLINECHECKS)
-        urt_delay_t deadlineOffset;
-    #endif /* URT_CFG_PUBSUB_QOS_DEADLINECHECKS */
-    #if (URT_CFG_PUBSUB_QOS_JITTERCHECKS)
-        urt_delay_t maxJitter;
-    #endif /* URT_CFG_PUBSUB_QOS_JITTERCHECKS */
-    #if (URT_CFG_PUBSUB_QOS_JITTERCHECKS || URT_CFG_PUBSUB_PROFILING)
-        urt_delay_t minLatency;
-        urt_delay_t maxLatency;
-    #endif /* URT_CFG_PUBSUB_QOS_JITTERCHECKS || URT_CFG_PUBSUB_PROFILING */
+  urt_basesubscriber_t base;
+  #if (URT_CFG_PUBSUB_QOS_DEADLINECHECKS)
+    urt_delay_t deadlineOffset;
+  #endif /* URT_CFG_PUBSUB_QOS_DEADLINECHECKS */
+  #if (URT_CFG_PUBSUB_QOS_JITTERCHECKS)
+    urt_delay_t maxJitter;
+  #endif /* URT_CFG_PUBSUB_QOS_JITTERCHECKS */
+  #if (URT_CFG_PUBSUB_QOS_JITTERCHECKS || URT_CFG_PUBSUB_PROFILING)
+    urt_delay_t minLatency;
+    urt_delay_t maxLatency;
+  #endif /* URT_CFG_PUBSUB_QOS_JITTERCHECKS || URT_CFG_PUBSUB_PROFILING */
 }urt_frtsubscriber_t;
 
 /**
@@ -105,22 +105,22 @@ typedef struct urt_frtsubscriber
  */
 typedef struct urt_hrtsubscriber
 {
-    urt_basesubscriber_t base;
-    urt_hrtsubscriber_t* next;
-    #if (URT_CFG_PUBSUB_QOS_DEADLINECHECKS)
-        urt_delay_t deadlineOffset;
-        urt_osTimer_t qosDeadlineTimer;
-    #endif /* URT_CFG_PUBSUB_QOS_DEADLINECHECKS */
-    #if (URT_CFG_PUBSUB_QOS_JITTERCHECKS)
-        urt_delay_t maxJitter;
-    #endif /* URT_CFG_PUBSUB_QOS_JITTERCHECKS */
-    #if (URT_CFG_PUBSUB_QOS_JITTERCHECKS || URT_CFG_PUBSUB_PROFILING)
-        urt_delay_t minLatency;
-        urt_delay_t maxLatency;
-    #endif /* URT_CFG_PUBSUB_QOS_JITTERCHECKS || URT_CFG_PUBSUB_PROFILING */
-    #if (URT_CFG_PUBSUB_QOS_RATECHECKS)
-        urt_delay_t expectedRate;
-    #endif /* URT_CFG_PUBSUB_QOS_RATECHECKS */
+  urt_basesubscriber_t base;
+  urt_hrtsubscriber_t* next;
+  #if (URT_CFG_PUBSUB_QOS_DEADLINECHECKS)
+    urt_delay_t deadlineOffset;
+    urt_osTimer_t qosDeadlineTimer;
+  #endif /* URT_CFG_PUBSUB_QOS_DEADLINECHECKS */
+  #if (URT_CFG_PUBSUB_QOS_JITTERCHECKS)
+    urt_delay_t maxJitter;
+  #endif /* URT_CFG_PUBSUB_QOS_JITTERCHECKS */
+  #if (URT_CFG_PUBSUB_QOS_JITTERCHECKS || URT_CFG_PUBSUB_PROFILING)
+    urt_delay_t minLatency;
+    urt_delay_t maxLatency;
+  #endif /* URT_CFG_PUBSUB_QOS_JITTERCHECKS || URT_CFG_PUBSUB_PROFILING */
+  #if (URT_CFG_PUBSUB_QOS_RATECHECKS)
+    urt_delay_t expectedRate;
+  #endif /* URT_CFG_PUBSUB_QOS_RATECHECKS */
 }urt_hrtsubscriber_t;
 
 /******************************************************************************/
@@ -135,31 +135,31 @@ typedef struct urt_hrtsubscriber
 extern "C" {
 #endif /* defined(__cplusplus) */
 
-    void urtNrtSubscriberInit(urt_nrtsubscriber_t* subscriber);
-    urt_status_t urtNrtSubscriberSubscribe(urt_nrtsubscriber_t* subscriber, urt_topic_t* topic, urt_message_t* messages);
-    urt_status_t urtNrtSubscriberFetchNextMessage(urt_nrtsubscriber_t* subscriber, void* payload, size_t bytes, urt_delay_t* latency);
-    urt_status_t urtNrtSubscriberFetchLatestMessage(urt_nrtsubscriber_t* subscriber, void* payload, size_t bytes, urt_delay_t* latency);
-    urt_status_t urtNrtSubscriberUnsubscribe(urt_nrtsubscriber_t* subscriber);
-
-    void urtSrtSubscriberInit(urt_srtsubscriber_t* subscriber);
-    urt_status_t urtSrtSubscriberSubscribe(urt_srtsubscriber_t* subscriber, urt_topic_t* topic, urt_message_t* message, urt_srtusefulnessfunc_t* usefulnesscb, void* cbparams);
-    urt_status_t urtSrtSubscriberFetchNextMessage(urt_srtsubscriber_t* subscriber, void* payload, size_t bytes, urt_delay_t* latency);
-    urt_status_t urtSrtSubscriberFetchLatestMessage(urt_srtsubscriber_t* subscriber, void* payload, size_t bytes, urt_delay_t* latency);
-    urt_status_t urtSrtSubscriberCalculateUsefulness(urt_srtsubscriber_t* subscriber, urt_delay_t latency);
-    urt_status_t urtSrtSubscriberUnsubscribe(urt_srtsubscriber_t* subscriber);
-
-    void urtFrtSubscriberInit(urt_frtsubscriber_t* subscriber);
-    urt_status_t urtFrtSubscriberSubscribe(urt_frtsubscriber_t* subscriber, urt_topic_t* topic, urt_message_t* messages, urt_delay_t deadline, urt_delay_t jitter);
-    urt_status_t urtFrtSubscriberFetchNextMessage(urt_frtsubscriber_t* subscriber, void* payload, size_t bytes, urt_delay_t* latency);
-    urt_status_t urtFrtSubscriberFetchLatestMessage(urt_frtsubscriber_t* subscriber, void* payload, size_t bytes, urt_delay_t* latency);
-    bool urtFrtSubscriberCalculateValidity(urt_frtsubscriber_t* subscriber, urt_delay_t latency);
-    urt_status_t urtFrtSubscriberUnsubscribe(urt_frtsubscriber_t* subscriber);
-
-    void urtHrtSubscriberInit(urt_hrtsubscriber_t* subscriber);
-    urt_status_t urtHrtSubscriberSubscribe(urt_hrtsubscriber_t* subscriber, urt_topic_t* topic, urt_message_t* message, urt_delay_t deadline, urt_delay_t rate, urt_delay_t jitter);
-    urt_status_t urtHrtSubscriberFetchNextMessage(urt_hrtsubscriber_t* subscriber, void* payload, size_t bytes, urt_delay_t* latency);
-    urt_status_t urtHrtSubscriberFetchLatestMessage(urt_hrtsubscriber_t* subscriber, void* payload, size_t bytes, urt_delay_t* latency);
-    urt_status_t urtHrtSubscriberUnsubscribe(urt_hrtsubscriber_t* subscriber);
+  void urtNrtSubscriberInit(urt_nrtsubscriber_t* subscriber);
+  urt_status_t urtNrtSubscriberSubscribe(urt_nrtsubscriber_t* subscriber, urt_topic_t* topic, urt_message_t* messages);
+  urt_status_t urtNrtSubscriberFetchNextMessage(urt_nrtsubscriber_t* subscriber, void* payload, size_t bytes, urt_delay_t* latency);
+  urt_status_t urtNrtSubscriberFetchLatestMessage(urt_nrtsubscriber_t* subscriber, void* payload, size_t bytes, urt_delay_t* latency);
+  urt_status_t urtNrtSubscriberUnsubscribe(urt_nrtsubscriber_t* subscriber);
+
+  void urtSrtSubscriberInit(urt_srtsubscriber_t* subscriber);
+  urt_status_t urtSrtSubscriberSubscribe(urt_srtsubscriber_t* subscriber, urt_topic_t* topic, urt_message_t* message, urt_srtusefulnessfunc_t* usefulnesscb, void* cbparams);
+  urt_status_t urtSrtSubscriberFetchNextMessage(urt_srtsubscriber_t* subscriber, void* payload, size_t bytes, urt_delay_t* latency);
+  urt_status_t urtSrtSubscriberFetchLatestMessage(urt_srtsubscriber_t* subscriber, void* payload, size_t bytes, urt_delay_t* latency);
+  urt_status_t urtSrtSubscriberCalculateUsefulness(urt_srtsubscriber_t* subscriber, urt_delay_t latency);
+  urt_status_t urtSrtSubscriberUnsubscribe(urt_srtsubscriber_t* subscriber);
+
+  void urtFrtSubscriberInit(urt_frtsubscriber_t* subscriber);
+  urt_status_t urtFrtSubscriberSubscribe(urt_frtsubscriber_t* subscriber, urt_topic_t* topic, urt_message_t* messages, urt_delay_t deadline, urt_delay_t jitter);
+  urt_status_t urtFrtSubscriberFetchNextMessage(urt_frtsubscriber_t* subscriber, void* payload, size_t bytes, urt_delay_t* latency);
+  urt_status_t urtFrtSubscriberFetchLatestMessage(urt_frtsubscriber_t* subscriber, void* payload, size_t bytes, urt_delay_t* latency);
+  bool urtFrtSubscriberCalculateValidity(urt_frtsubscriber_t* subscriber, urt_delay_t latency);
+  urt_status_t urtFrtSubscriberUnsubscribe(urt_frtsubscriber_t* subscriber);
+
+  void urtHrtSubscriberInit(urt_hrtsubscriber_t* subscriber);
+  urt_status_t urtHrtSubscriberSubscribe(urt_hrtsubscriber_t* subscriber, urt_topic_t* topic, urt_message_t* message, urt_delay_t deadline, urt_delay_t rate, urt_delay_t jitter);
+  urt_status_t urtHrtSubscriberFetchNextMessage(urt_hrtsubscriber_t* subscriber, void* payload, size_t bytes, urt_delay_t* latency);
+  urt_status_t urtHrtSubscriberFetchLatestMessage(urt_hrtsubscriber_t* subscriber, void* payload, size_t bytes, urt_delay_t* latency);
+  urt_status_t urtHrtSubscriberUnsubscribe(urt_hrtsubscriber_t* subscriber);
 #if defined(__cplusplus)
 }
 #endif /* defined(__cplusplus) */